<%@ page language="java"  pageEncoding="EUC_JP"
         contentType="text/html;charset=EUC_JP" %>
<%-- Ѥ륿饤֥֤̾(core, fmt, sql, functions) --%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core"      prefix="c"   %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt"       prefix="fmt" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/sql"       prefix="sql" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"  %>
<fmt:requestEncoding value="JISAutoDetect" />
<c:catch var="error">
  <sql:setDataSource dataSource="jdbc/tagwebDB" var="dataSource" scope="session" />
  <sql:transaction dataSource="${dataSource}" isolation="repeatable_read">
    <c:if test="${!empty paramValues.id}">
      <c:forEach var="id" items="${paramValues.id}">
        <sql:update sql="DELETE FROM purchase WHERE id = ?">
          <sql:param value="${id}" />
        </sql:update>
      </c:forEach>
    </c:if>
    <c:if test="${!empty param.name  and  !empty param.price  and  !empty param.quantity}">
      <sql:update>
        INSERT INTO purchase ( name, price, quantity ) VALUES ( ?, ?, ? )
        <sql:param value="${fn:trim(param.name)}" />
        <sql:param value="${param.price}" />
        <sql:param value="${param.quantity}" />
      </sql:update>
    </c:if>
  </sql:transaction>
  <sql:query dataSource="${dataSource}" var="purchase">
    SELECT *, price * quantity AS subtotal FROM purchase ORDER BY id
  </sql:query>
  <sql:query dataSource="${dataSource}" var="total">
    SELECT CAST( SUM( price * quantity ) AS UNSIGNED ) AS total FROM purchase
  </sql:query>
</c:catch>
<html>
  <head>
    <style type="text/css"><!--
      table    {  width           : 100%;       }
      td, th   {  background      : #dddddd;
                  padding         : 3pt;        }
      div      {  font-weight : bold;
                  text-decoration : underline;  }
      .right   {  text-align      : right;      }
      .center  {  text-align      : center;     }
    --></style>
    <title>My First JSTL (sql02.jsp:query, update, transaction)</title>
  </head>
  <body>
    <h3>JSTLSQL¹(sql02.jsp:query, update, transaction)</h3>
    <div>㤤ʪꥹ ס${total.rowsByIndex[0][0]}</div>
    <form method="post" action="sql02.jsp">
      <table>
        <thead>
          <tr><th></th><th>ID</th><th></th><th>ǹ</th><th></th><th></th></tr>
        </thead>
        <tbody>
          <c:forEach var="row" items="${purchase.rows}">
            <tr>
              <th><input type="checkbox" name="id" value="${row.id}"></th>
              <td class="center">${row.id}</td>
              <td>${fn:escapeXml(row.name)}</td>
              <td class="right">${row.price}</td>
              <td class="right">${row.quantity}</td>
              <td class="right">${row.subtotal}</td>
            </tr>
          </c:forEach>
        </tbody>
      </table>
      <input type="text" name="name" size="30">
      ǹ<input class="right" type="text" name="price" size="6">
      <input class="right" type="text" name="quantity" size="3">
      <input type="submit" value="ɲá"><input type="reset" value="ꥻå">
    </form>
    <c:if test="${!empty error}">
      ǡ١˥ǤޤǤ<br>
      ${error}
    </c:if>
  </body>
</html>